Foreman - Bug #6998

Cannot rename host by API due to DHCP conflict - cannot set 'overwrite' flag
08/07/2014 07:17 PM - Aaron Stone

Status: Closed
Priority: Normal
Assignee: Aaron Stone
Category: API
Target version: 1.6.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/1677
Description
Steps in Ul:

In the Foreman Ul, rename a host.
Foreman shows a DHCP conflict for the MAC Address to the old name.
Click the Overwrite button.

Steps in API:

Submit form to /api/hosts/hostid with content {"name": "newname"} and an APIv2 header version

Receive error message {"error"=>{"full_messages"=>["Conflict DHCP records spare-12345-macaddr/ipaddr and
spare-12345-macaddr/ipaddr already exists"] ... }

Try again with {"name": "newname", "overwrite": true}

Receive same error.

Expected:
| should be able to overwrite from the API.

This is with Foreman 1.5.1.

Associated revisions

Revision a0d231da - 08/15/2014 08:12 AM - Aaron Stone

Fixes #6998 - Accept native true for overwrite parameter to host API.

Revision 8f7d8b3c - 08/27/2014 08:02 AM - Aaron Stone

Fixes #6998 - Accept native true for overwrite parameter to host API.

(cherry picked from commit a0d231daf018694a4aec708c2d8e32e69492a84a)

History

#1 - 08/07/2014 07:18 PM - Aaron Stone

Does this commit for Foreman 1.6.0 implement overwrite? @isratrade
https://github.com/theforeman/foreman/commit/c980e9a8917cc9fdee5835732428462e22fa3f5b

#2 - 08/11/2014 03:45 AM - Dominic Cleal
- Category set to API

That commit will help if you're using an unwrapped set of JSON, i.e. it'll make {"overwrite":true, ...} work. Before it, only the wrapped version
{"host":{"overwrite":true, ...}} will work.

#3 - 08/11/2014 09:44 AM - Aaron Stone

Actually, | found that | had to set {"overwrite":"true"} in quotes, because of this:

https://github.com/theforeman/foreman/blob/develop/app/models/host/managed.rb#L611-614
https://github.com/theforeman/foreman/commit/c980e9a8917cc9fdee5835732428462e22fa3f5b
https://github.com/theforeman/foreman/blob/develop/app/models/host/managed.rb#L611-614

# We have to coerce the value back to boolean. It is not done for us by the framework.
def overwrite=(value)

Qoverwrite = value == "true"
end

Is there some way to put a flexible truthiness test into the API or Controller, rather than in the model?

#4 - 08/11/2014 09:52 AM - Dominic Cleal

Ah. It could be at the controller level, but it'd be much less duplication in the model - you could simply use value.to_s == "true" instead. Generally
Rails does string/bool stuff at the ActiveRecord layer, which isn't applicable for a setter.

#5 - 08/11/2014 11:07 AM - Aaron Stone
| will submit a PR shortly!

#6 - 08/11/2014 11:28 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Target version setto 1.7.5

- Pull request https://github.com/theforeman/foreman/pull/1677 added
- Pull request deleted ()

#7 - 08/11/2014 11:30 AM - Dominic Cleal

- Assignee set to Aaron Stone

#8 - 08/15/2014 08:09 AM - Dominic Cleal

- translation missing: en.field_release set to 10

#9 - 08/15/2014 09:02 AM - Aaron Stone
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset a0d231daf018694a4aec708c2d8e32e69492a84a.
